Index: issm/trunk/src/m/plot/applyoptions.m
===================================================================
--- issm/trunk/src/m/plot/applyoptions.m	(revision 25994)
+++ issm/trunk/src/m/plot/applyoptions.m	(revision 26744)
@@ -52,5 +52,5 @@
 if exist(options,'axis')
 	axisopts = getfieldvalue(options,'axis');
-	if ischar(axisopts) & contains(axisopts,' ');
+	if ischar(axisopts) & any(axisopts==' ');
 		axisopts = strsplit(axisopts);
 		axis(axisopts{:});
@@ -289,4 +289,41 @@
 		shpdisp(filenamei,1,stylei,linewidthi,getfieldvalue(options,'unit',1));
 	end
+end
+if exist(options,'contours'),
+
+	hold on;
+	contours=getfieldvalue(options,'contours');
+	style=getfieldvalue(options,'contourstyle',{'-'});
+	linewidth=getfieldvalue(options,'linewidth',{1});
+	color=getfieldvalue(options,'contourcolor',{'r'});
+	contourheight=getfieldvalue(options,'contourheight',1); 
+
+	radius=md.solidearth.planetradius;
+	ratio=1+(contourheight*1000/radius);
+
+	
+	if ~isa(contours,'cell'),
+		contours={contours};
+	end
+	nc=length(contours);
+	if ~isa(style,'cell'), error('contour style should be a cell array'); end
+	if ~isa(linewidth,'cell'), error('contour line width should be a cell array'); end
+	if ~isa(color,'cell'), error('contour color should be a cell array'); end
+
+	for i=1:length(contours),
+		ci=contours{i};
+		if length(style)==1, sti=style{1}; else sti=style{i}; end
+		if length(color)==1, coli=color{1}; else coli=color{i}; end
+		if length(linewidth)==1, li=linewidth{1}; else li=linewidth{i}; end
+
+		for j=1:length(ci),
+			cijx=ci(j).x*ratio;
+			cijy=ci(j).y*ratio;
+			cijz=ci(j).z*ratio;
+
+			plot3(cijx,cijy,cijz,'LineWidth',li,'LineStyle',sti,'Color',coli);
+		end
+	end
+
 end
 
@@ -448,10 +485,26 @@
 
 %flag edges of a partition
-if exist(options,'partitionedges') & ~strcmp(getfieldvalue(options,'partitionedges','off'),'off')
-	mdp=getfieldvalue(options,'partitionedges','off');
-	if ischar(mdp)
-		mdp=md;
-	end
-	[xsegments ysegments]=flagedges(mdp.mesh.elements,mdp.mesh.x,mdp.mesh.y,mdp.qmu.partition);
+%
+% TODO:
+% - Figure out how to expand string representing an object (e.g. 
+%	'md.qmu.variables.thickness.partition') to get the actual value *without* 
+%	using `eval` and like functions (md.('token').('token') works, but how do 
+%	we access md given the string 'md').
+if exist(options,'partition')
+	partition=getfieldvalue(options,'partition','');
+	if isvector(partition) & isnumeric(partition) % partition option is vector
+		% do nothing: we already have a partition vector
+	% elseif ischar(partition) & ~isempty(partition) % partition option is string
+	% 	% expand string
+	% 	partition=eval(partition);
+	% 	class(partition);
+	% 	if ~(isvector(partition) & isnumeric(partition))
+	% 		error('String passed to ''partition'' option does not represent a partition vector');
+	% 	end
+	else
+		error('If ''partition'' option is supplied, it should be a partition vector object');
+	end
+	mdp=md;
+	[xsegments ysegments]=flagedges(mdp.mesh.elements,mdp.mesh.x,mdp.mesh.y,partition);
 	xsegments=xsegments*getfieldvalue(options,'unit',1);
 	ysegments=ysegments*getfieldvalue(options,'unit',1);
Index: issm/trunk/src/m/plot/checkplotoptions.py
===================================================================
--- issm/trunk/src/m/plot/checkplotoptions.py	(revision 25994)
+++ issm/trunk/src/m/plot/checkplotoptions.py	(revision 26744)
@@ -3,21 +3,20 @@
 
 def checkplotoptions(md, options):
-    '''
-    CHECKPLOTOPTIONS - build a structure that holds all plot options
+    """CHECKPLOTOPTIONS - build a structure that holds all plot options
 
-        Usage:
-            options = checkplotoptions(md, options)
+    Usage:
+        options = checkplotoptions(md, options)
 
-        See also: PLOTMODEL
+    See also: PLOTMODEL
 
-        NOTE: not fully implemented yet
-    '''
+    NOTE: not fully implemented yet
+    """
 
     # {{{ units
     if options.exist('unit'):
         if 'km' in options.getfieldvalue('unit', 'km'):
-            options.changefieldvalue('unit', 10**-3)
+            options.changefieldvalue('unit', pow(10, -3))
         elif '100km' in options.getfieldvalue('unit', '100km'):
-            options.changefieldvalue('unit', 10**-5)
+            options.changefieldvalue('unit', pow(10, -5))
     # }}}
     # {{{ density
@@ -62,5 +61,5 @@
         textlist.extend([text] if isinstance(text, str) else text)
         numtext = len(textlist)
-    # text position
+        # text position
         textpos = options.getfieldvalue('textposition', [0.5, 0.5])
         if not isinstance(textpos, list):
@@ -75,5 +74,5 @@
             raise Exception('textposition should contain one list of x, y vertices for every text instance')
 
-    # font size
+        # font size
         if options.exist('textfontsize'):
             textfontsize = options.getfieldvalue('textfontsize', 12)
@@ -85,5 +84,5 @@
             sizelist = np.tile(sizelist, numtext)
 
-    # font color
+        # font color
         if options.exist('textcolor'):
             textcolor = options.getfieldvalue('textcolor', 'k')
@@ -95,5 +94,5 @@
             colorlist = np.tile(colorlist, numtext)
 
-    # textweight
+        # textweight
         if options.exist('textweight'):
             textweight = options.getfieldvalue('textweight')
@@ -105,5 +104,5 @@
             weightlist = np.tile(weightlist, numtext)
 
-    # text rotation
+        # text rotation
         if options.exist('textrotation'):
             textrotation = options.getfieldvalue('textrotation', 0)
@@ -152,5 +151,5 @@
     if options.exist('northarrow'):
         if 'on' in options.getfieldvalue('northarrow', 'on'):
-            #default values
+            # default values
             Lx = max(md.mesh.x) - min(md.mesh.x)
             Ly = max(md.mesh.y) - min(md.mesh.y)
Index: issm/trunk/src/m/plot/colormaps/demmap.py
===================================================================
--- issm/trunk/src/m/plot/colormaps/demmap.py	(revision 25994)
+++ issm/trunk/src/m/plot/colormaps/demmap.py	(revision 26744)
@@ -64,6 +64,4 @@
         cmx = nland * interval
 
-    clim = [cmn, cmx]
-
     if strcmpi(colorscheme, 'dem'):
         # concatenate and transpose to match matplotlib's colormap format
Index: issm/trunk/src/m/plot/colormaps/turbo.m
===================================================================
--- issm/trunk/src/m/plot/colormaps/turbo.m	(revision 26744)
+++ issm/trunk/src/m/plot/colormaps/turbo.m	(revision 26744)
@@ -0,0 +1,279 @@
+function map = turbo(m)
+%TURBO   Turbo colormap.
+%   TURBO(M) returns an M-by-3 matrix containing the turbo colormap, a
+%   variant of the jet colormap that is more perceptually uniform.
+%
+%   See also JET, COLORMAP.
+%	 
+%		Daniel Fortunato (2021). turbo (https://www.mathworks.com/matlabcentral/fileexchange/74662-turbo), MATLAB Central File Exchange. Retrieved August 4, 2021. 
+%
+%	more info: https://ai.googleblog.com/2019/08/turbo-improved-rainbow-colormap-for.html
+%
+if nargin < 1
+   f = get(groot,'CurrentFigure');
+   if isempty(f)
+      m = size(get(groot,'DefaultFigureColormap'),1);
+   else
+      m = size(f.Colormap,1);
+   end
+end
+values = [
+     0.18995, 0.07176, 0.23217;
+     0.19483, 0.08339, 0.26149;
+     0.19956, 0.09498, 0.29024;
+     0.20415, 0.10652, 0.31844;
+     0.20860, 0.11802, 0.34607;
+     0.21291, 0.12947, 0.37314;
+     0.21708, 0.14087, 0.39964;
+     0.22111, 0.15223, 0.42558;
+     0.22500, 0.16354, 0.45096;
+     0.22875, 0.17481, 0.47578;
+     0.23236, 0.18603, 0.50004;
+     0.23582, 0.19720, 0.52373;
+     0.23915, 0.20833, 0.54686;
+     0.24234, 0.21941, 0.56942;
+     0.24539, 0.23044, 0.59142;
+     0.24830, 0.24143, 0.61286;
+     0.25107, 0.25237, 0.63374;
+     0.25369, 0.26327, 0.65406;
+     0.25618, 0.27412, 0.67381;
+     0.25853, 0.28492, 0.69300;
+     0.26074, 0.29568, 0.71162;
+     0.26280, 0.30639, 0.72968;
+     0.26473, 0.31706, 0.74718;
+     0.26652, 0.32768, 0.76412;
+     0.26816, 0.33825, 0.78050;
+     0.26967, 0.34878, 0.79631;
+     0.27103, 0.35926, 0.81156;
+     0.27226, 0.36970, 0.82624;
+     0.27334, 0.38008, 0.84037;
+     0.27429, 0.39043, 0.85393;
+     0.27509, 0.40072, 0.86692;
+     0.27576, 0.41097, 0.87936;
+     0.27628, 0.42118, 0.89123;
+     0.27667, 0.43134, 0.90254;
+     0.27691, 0.44145, 0.91328;
+     0.27701, 0.45152, 0.92347;
+     0.27698, 0.46153, 0.93309;
+     0.27680, 0.47151, 0.94214;
+     0.27648, 0.48144, 0.95064;
+     0.27603, 0.49132, 0.95857;
+     0.27543, 0.50115, 0.96594;
+     0.27469, 0.51094, 0.97275;
+     0.27381, 0.52069, 0.97899;
+     0.27273, 0.53040, 0.98461;
+     0.27106, 0.54015, 0.98930;
+     0.26878, 0.54995, 0.99303;
+     0.26592, 0.55979, 0.99583;
+     0.26252, 0.56967, 0.99773;
+     0.25862, 0.57958, 0.99876;
+     0.25425, 0.58950, 0.99896;
+     0.24946, 0.59943, 0.99835;
+     0.24427, 0.60937, 0.99697;
+     0.23874, 0.61931, 0.99485;
+     0.23288, 0.62923, 0.99202;
+     0.22676, 0.63913, 0.98851;
+     0.22039, 0.64901, 0.98436;
+     0.21382, 0.65886, 0.97959;
+     0.20708, 0.66866, 0.97423;
+     0.20021, 0.67842, 0.96833;
+     0.19326, 0.68812, 0.96190;
+     0.18625, 0.69775, 0.95498;
+     0.17923, 0.70732, 0.94761;
+     0.17223, 0.71680, 0.93981;
+     0.16529, 0.72620, 0.93161;
+     0.15844, 0.73551, 0.92305;
+     0.15173, 0.74472, 0.91416;
+     0.14519, 0.75381, 0.90496;
+     0.13886, 0.76279, 0.89550;
+     0.13278, 0.77165, 0.88580;
+     0.12698, 0.78037, 0.87590;
+     0.12151, 0.78896, 0.86581;
+     0.11639, 0.79740, 0.85559;
+     0.11167, 0.80569, 0.84525;
+     0.10738, 0.81381, 0.83484;
+     0.10357, 0.82177, 0.82437;
+     0.10026, 0.82955, 0.81389;
+     0.09750, 0.83714, 0.80342;
+     0.09532, 0.84455, 0.79299;
+     0.09377, 0.85175, 0.78264;
+     0.09287, 0.85875, 0.77240;
+     0.09267, 0.86554, 0.76230;
+     0.09320, 0.87211, 0.75237;
+     0.09451, 0.87844, 0.74265;
+     0.09662, 0.88454, 0.73316;
+     0.09958, 0.89040, 0.72393;
+     0.10342, 0.89600, 0.71500;
+     0.10815, 0.90142, 0.70599;
+     0.11374, 0.90673, 0.69651;
+     0.12014, 0.91193, 0.68660;
+     0.12733, 0.91701, 0.67627;
+     0.13526, 0.92197, 0.66556;
+     0.14391, 0.92680, 0.65448;
+     0.15323, 0.93151, 0.64308;
+     0.16319, 0.93609, 0.63137;
+     0.17377, 0.94053, 0.61938;
+     0.18491, 0.94484, 0.60713;
+     0.19659, 0.94901, 0.59466;
+     0.20877, 0.95304, 0.58199;
+     0.22142, 0.95692, 0.56914;
+     0.23449, 0.96065, 0.55614;
+     0.24797, 0.96423, 0.54303;
+     0.26180, 0.96765, 0.52981;
+     0.27597, 0.97092, 0.51653;
+     0.29042, 0.97403, 0.50321;
+     0.30513, 0.97697, 0.48987;
+     0.32006, 0.97974, 0.47654;
+     0.33517, 0.98234, 0.46325;
+     0.35043, 0.98477, 0.45002;
+     0.36581, 0.98702, 0.43688;
+     0.38127, 0.98909, 0.42386;
+     0.39678, 0.99098, 0.41098;
+     0.41229, 0.99268, 0.39826;
+     0.42778, 0.99419, 0.38575;
+     0.44321, 0.99551, 0.37345;
+     0.45854, 0.99663, 0.36140;
+     0.47375, 0.99755, 0.34963;
+     0.48879, 0.99828, 0.33816;
+     0.50362, 0.99879, 0.32701;
+     0.51822, 0.99910, 0.31622;
+     0.53255, 0.99919, 0.30581;
+     0.54658, 0.99907, 0.29581;
+     0.56026, 0.99873, 0.28623;
+     0.57357, 0.99817, 0.27712;
+     0.58646, 0.99739, 0.26849;
+     0.59891, 0.99638, 0.26038;
+     0.61088, 0.99514, 0.25280;
+     0.62233, 0.99366, 0.24579;
+     0.63323, 0.99195, 0.23937;
+     0.64362, 0.98999, 0.23356;
+     0.65394, 0.98775, 0.22835;
+     0.66428, 0.98524, 0.22370;
+     0.67462, 0.98246, 0.21960;
+     0.68494, 0.97941, 0.21602;
+     0.69525, 0.97610, 0.21294;
+     0.70553, 0.97255, 0.21032;
+     0.71577, 0.96875, 0.20815;
+     0.72596, 0.96470, 0.20640;
+     0.73610, 0.96043, 0.20504;
+     0.74617, 0.95593, 0.20406;
+     0.75617, 0.95121, 0.20343;
+     0.76608, 0.94627, 0.20311;
+     0.77591, 0.94113, 0.20310;
+     0.78563, 0.93579, 0.20336;
+     0.79524, 0.93025, 0.20386;
+     0.80473, 0.92452, 0.20459;
+     0.81410, 0.91861, 0.20552;
+     0.82333, 0.91253, 0.20663;
+     0.83241, 0.90627, 0.20788;
+     0.84133, 0.89986, 0.20926;
+     0.85010, 0.89328, 0.21074;
+     0.85868, 0.88655, 0.21230;
+     0.86709, 0.87968, 0.21391;
+     0.87530, 0.87267, 0.21555;
+     0.88331, 0.86553, 0.21719;
+     0.89112, 0.85826, 0.21880;
+     0.89870, 0.85087, 0.22038;
+     0.90605, 0.84337, 0.22188;
+     0.91317, 0.83576, 0.22328;
+     0.92004, 0.82806, 0.22456;
+     0.92666, 0.82025, 0.22570;
+     0.93301, 0.81236, 0.22667;
+     0.93909, 0.80439, 0.22744;
+     0.94489, 0.79634, 0.22800;
+     0.95039, 0.78823, 0.22831;
+     0.95560, 0.78005, 0.22836;
+     0.96049, 0.77181, 0.22811;
+     0.96507, 0.76352, 0.22754;
+     0.96931, 0.75519, 0.22663;
+     0.97323, 0.74682, 0.22536;
+     0.97679, 0.73842, 0.22369;
+     0.98000, 0.73000, 0.22161;
+     0.98289, 0.72140, 0.21918;
+     0.98549, 0.71250, 0.21650;
+     0.98781, 0.70330, 0.21358;
+     0.98986, 0.69382, 0.21043;
+     0.99163, 0.68408, 0.20706;
+     0.99314, 0.67408, 0.20348;
+     0.99438, 0.66386, 0.19971;
+     0.99535, 0.65341, 0.19577;
+     0.99607, 0.64277, 0.19165;
+     0.99654, 0.63193, 0.18738;
+     0.99675, 0.62093, 0.18297;
+     0.99672, 0.60977, 0.17842;
+     0.99644, 0.59846, 0.17376;
+     0.99593, 0.58703, 0.16899;
+     0.99517, 0.57549, 0.16412;
+     0.99419, 0.56386, 0.15918;
+     0.99297, 0.55214, 0.15417;
+     0.99153, 0.54036, 0.14910;
+     0.98987, 0.52854, 0.14398;
+     0.98799, 0.51667, 0.13883;
+     0.98590, 0.50479, 0.13367;
+     0.98360, 0.49291, 0.12849;
+     0.98108, 0.48104, 0.12332;
+     0.97837, 0.46920, 0.11817;
+     0.97545, 0.45740, 0.11305;
+     0.97234, 0.44565, 0.10797;
+     0.96904, 0.43399, 0.10294;
+     0.96555, 0.42241, 0.09798;
+     0.96187, 0.41093, 0.09310;
+     0.95801, 0.39958, 0.08831;
+     0.95398, 0.38836, 0.08362;
+     0.94977, 0.37729, 0.07905;
+     0.94538, 0.36638, 0.07461;
+     0.94084, 0.35566, 0.07031;
+     0.93612, 0.34513, 0.06616;
+     0.93125, 0.33482, 0.06218;
+     0.92623, 0.32473, 0.05837;
+     0.92105, 0.31489, 0.05475;
+     0.91572, 0.30530, 0.05134;
+     0.91024, 0.29599, 0.04814;
+     0.90463, 0.28696, 0.04516;
+     0.89888, 0.27824, 0.04243;
+     0.89298, 0.26981, 0.03993;
+     0.88691, 0.26152, 0.03753;
+     0.88066, 0.25334, 0.03521;
+     0.87422, 0.24526, 0.03297;
+     0.86760, 0.23730, 0.03082;
+     0.86079, 0.22945, 0.02875;
+     0.85380, 0.22170, 0.02677;
+     0.84662, 0.21407, 0.02487;
+     0.83926, 0.20654, 0.02305;
+     0.83172, 0.19912, 0.02131;
+     0.82399, 0.19182, 0.01966;
+     0.81608, 0.18462, 0.01809;
+     0.80799, 0.17753, 0.01660;
+     0.79971, 0.17055, 0.01520;
+     0.79125, 0.16368, 0.01387;
+     0.78260, 0.15693, 0.01264;
+     0.77377, 0.15028, 0.01148;
+     0.76476, 0.14374, 0.01041;
+     0.75556, 0.13731, 0.00942;
+     0.74617, 0.13098, 0.00851;
+     0.73661, 0.12477, 0.00769;
+     0.72686, 0.11867, 0.00695;
+     0.71692, 0.11268, 0.00629;
+     0.70680, 0.10680, 0.00571;
+     0.69650, 0.10102, 0.00522;
+     0.68602, 0.09536, 0.00481;
+     0.67535, 0.08980, 0.00449;
+     0.66449, 0.08436, 0.00424;
+     0.65345, 0.07902, 0.00408;
+     0.64223, 0.07380, 0.00401;
+     0.63082, 0.06868, 0.00401;
+     0.61923, 0.06367, 0.00410;
+     0.60746, 0.05878, 0.00427;
+     0.59550, 0.05399, 0.00453;
+     0.58336, 0.04931, 0.00486;
+     0.57103, 0.04474, 0.00529;
+     0.55852, 0.04028, 0.00579;
+     0.54583, 0.03593, 0.00638;
+     0.53295, 0.03169, 0.00705;
+     0.51989, 0.02756, 0.00780;
+     0.50664, 0.02354, 0.00863;
+     0.49321, 0.01963, 0.00955;
+     0.47960, 0.01583, 0.01055];
+P = size(values,1);
+map = interp1(1:P, values, linspace(1,P,m), 'linear');
+end
Index: issm/trunk/src/m/plot/googlemaps.m
===================================================================
--- issm/trunk/src/m/plot/googlemaps.m	(revision 25994)
+++ issm/trunk/src/m/plot/googlemaps.m	(revision 26744)
@@ -175,8 +175,8 @@
 delete('temp.png');
 
-%If not gdal, exit
+%If not GDAL, exit
 if status~=0,
 	disp(result);
-	disp('googlemaps info: gdal not found or not working properly, the Google image will not be transformed');
+	disp('googlemaps info: GDAL not found or not working properly, the Google image will not be transformed');
 	[gX gY]=meshgrid(ulx:ulx+size(final,2)-1,uly:-1:uly-size(final,1)+1);
 	[LAT LON]=pixelstolatlon(gX,gY, zoom);
@@ -204,5 +204,5 @@
 if ~isempty(strfind(result,'ERROR')),
 	disp(result);
-	disp(' ');disp('googlemaps info: gdal not working properly (missing proj.4 library?), Google image will not be transformed');
+	disp(' ');disp('googlemaps info: GDAL not working properly (missing PROJ.4 library?), Google image will not be transformed');
 	disp(result);
 	[gX gY]=meshgrid(ulx:ulx+size(final,2)-1,uly:-1:uly-size(final,1)+1);
Index: issm/trunk/src/m/plot/plot_contour.js
===================================================================
--- issm/trunk/src/m/plot/plot_contour.js	(revision 26744)
+++ issm/trunk/src/m/plot/plot_contour.js	(revision 26744)
@@ -0,0 +1,300 @@
+function plot_contour(md, datain, options, canvas) { //{{{
+	//PLOT_MESH - Function for plotting wireframe contour.
+	//
+	//   Usage:
+	//      plot_contour(md, options, canvas);
+	//
+	//   See also: PLOTMODEL, PLOT_MANAGER
+
+	//{{{
+	//Process data and model
+	//let meshresults = processmesh(md, [], options);
+	//let [x, y, z, index, is2d, isplanet, vertices, scale] = scaleMesh(md, meshresults, options);
+	let [x, y, z, index, is2d, isplanet]=processmesh(md,[],options);
+	options.removefield('log',0);;
+	let [data, datatype]=processdata(md,datain,options);
+	if (vesl.helpers.isEmptyOrUndefined(data)) error('data provided is empty');
+	
+	//check is2d
+	if (!is2d && !isplanet) {
+		error('plot_contour error message: contour not supported for 3d meshes, project on a layer');
+	}
+
+	//first, process data: must be on nodes
+	if (datatype==1) {
+		//elements -> take average
+		//data=averaging(md,data,0);
+		error('plot_contour error message: contour not supported for element data yet');
+	} else if (datatype==2) {
+		//nodes -> do nothing
+	} else if (datatype==3) {
+		//quiver -> take norm
+		//data=sqrt(sum(datain.*datain,2)); //(original)
+		//data=ArraySqrt(ArraySum(ArrayMultiply(datain, datain),2)); //js version
+		error('plot_contour error message: contour not supported for quiver data yet');
+	} else {
+		error('datatype not supported yet');
+	}
+
+	//prepare colors
+	if (options.exist('contouronly')) {
+		//remove the previous plots
+		//cla
+		error('contouronly not supported yet');
+	}
+	let color=options.getfieldvalue('contourcolor','yellow');
+	let linewidth=options.getfieldvalue('linewidth',1);
+
+	//get contours levels
+	let contourlevels=options.getfieldvalue('contourlevels');
+	let levels;
+	if (typeof(contourlevels) == 'number') {
+		//levels=round_ice(linspace(max(data),min(data),contourlevels),2);
+		error('numeric contourlevels not supported yet - must provide levels as an array');
+	} else {
+		//levels=sort(unique(levels),'descend');
+		levels=ArraySort(ArrayUnique(contourlevels)).reverse();
+	}
+	let numlevels=levels.length;
+
+	//initialization of some variables
+	let numberofelements=index.length; //same as size(index,1)
+	let elementslist=NewArrayFillIncrement(0,numberofelements,1); //1:numberofelements;
+	let c=[];
+	let h=[];;
+
+	//get unique edges in mesh
+	//1: list of edges
+	index = ArraySubtract2D(index, 1);
+	//edges=[index[:,[1,2]); index(:,[2,3]); index(:,[3,1])];
+	let edges=ArrayConcat(ArrayConcat(ArrayCol(index,[0,1]), ArrayCol(index,[1,2])), ArrayCol(index,[2,0]));
+	//2: find unique edges
+	//[edges,I,J]=unique(sort(edges,2),'rows');
+	[edges,I,J]=ArrayUnique(ArraySort(edges,2),'rows');
+	//3: unique edge numbers
+	let vec=J;
+	//4: unique edges numbers in each triangle (2 triangles sharing the same edge will have
+	//   the same edge number)
+	let edges_tria=ArrayTranspose([ArrayIndex(vec,elementslist), ArrayIndex(vec,ArrayAdd(elementslist,numberofelements)), ArrayIndex(vec,ArrayAdd(elementslist,2*numberofelements))]);
+
+	//segments [nodes1 nodes2]
+	let Seg1=ArrayCol(index,[0,1]);
+	let Seg2=ArrayCol(index,[1,2]);
+	let Seg3=ArrayCol(index,[2,0]);
+	
+	//segment numbers [1;4;6;...]
+	let Seg1_num=ArrayCol(edges_tria,0);
+	let Seg2_num=ArrayCol(edges_tria,1);
+	let Seg3_num=ArrayCol(edges_tria,2);
+
+	//value of data on each tips of the segments
+	let Data1=ArrayIndex(data,Seg1);
+	let Data2=ArrayIndex(data,Seg2);
+	let Data3=ArrayIndex(data,Seg3);
+
+	//get the ranges for each segment
+	let Range1=ArraySort(Data1,2);
+	let Range2=ArraySort(Data2,2);
+	let Range3=ArraySort(Data3,2);
+	
+	let hx = [];
+	let hy = [];
+	let hz = [];
+	for (let i=0; i<numlevels; i++) {
+		let level=levels[i];
+
+		//find the segments that contain this value
+		let pos1=ArrayAnd(ArrayLessThan(ArrayCol(Range1,0),level), ArrayGreaterThan(ArrayCol(Range1,1),level)); //pos1=(Range1(:,1)<level & Range1(:,2)>level);
+		let pos2=ArrayAnd(ArrayLessThan(ArrayCol(Range2,0),level), ArrayGreaterThan(ArrayCol(Range2,1),level)); //pos2=(Range2(:,1)<level & Range2(:,2)>level);
+		let pos3=ArrayAnd(ArrayLessThan(ArrayCol(Range3,0),level), ArrayGreaterThan(ArrayCol(Range3,1),level)); //pos3=(Range3(:,1)<level & Range3(:,2)>level);
+
+		//get elements
+		let poselem12=ArrayAnd(pos1, pos2);
+		let poselem13=ArrayAnd(pos1, pos3);
+		let poselem23=ArrayAnd(pos2, pos3);
+		let poselem=find(ArrayOr(ArrayOr(poselem12, poselem13), poselem23));
+		let numelems=length(poselem);
+
+		//if no element has been flagged, skip to the next level
+		if (numelems==0) {
+			continue;
+		}
+
+		//go through the elements and build the coordinates for each segment (1 by element)
+		let x1=zeros(numelems,1);
+		let x2=zeros(numelems,1);
+		let y1=zeros(numelems,1);
+		let y2=zeros(numelems,1);
+		let z1=zeros(numelems,1);
+		let z2=zeros(numelems,1);
+
+		let edge_l=zeros(numelems,2);
+
+		for (let j=0; j < numelems; j++) {
+
+			let weight1=(level-Data1[poselem[j]][0])/(Data1[poselem[j]][1]-Data1[poselem[j]][0]);
+			let weight2=(level-Data2[poselem[j]][0])/(Data2[poselem[j]][1]-Data2[poselem[j]][0]);
+			let weight3=(level-Data3[poselem[j]][0])/(Data3[poselem[j]][1]-Data3[poselem[j]][0]);
+
+			if (poselem12[poselem[j]]) {
+				x1[j]=x[Seg1[poselem[j]][0]]+weight1*(x[Seg1[poselem[j]][1]]-x[Seg1[poselem[j]][0]]);
+				x2[j]=x[Seg2[poselem[j]][0]]+weight2*(x[Seg2[poselem[j]][1]]-x[Seg2[poselem[j]][0]]);
+				y1[j]=y[Seg1[poselem[j]][0]]+weight1*(y[Seg1[poselem[j]][1]]-y[Seg1[poselem[j]][0]]);
+				y2[j]=y[Seg2[poselem[j]][0]]+weight2*(y[Seg2[poselem[j]][1]]-y[Seg2[poselem[j]][0]]);
+				z1[j]=z[Seg1[poselem[j]][0]]+weight1*(z[Seg1[poselem[j]][1]]-z[Seg1[poselem[j]][0]]);
+				z2[j]=z[Seg2[poselem[j]][0]]+weight2*(z[Seg2[poselem[j]][1]]-z[Seg2[poselem[j]][0]]);
+				edge_l[j][0]=Seg1_num[poselem[j]];
+				edge_l[j][1]=Seg2_num[poselem[j]];
+
+			} else if (poselem13[poselem[j]]) {
+                x1[j]=x[Seg1[poselem[j]][0]]+weight1*(x[Seg1[poselem[j]][1]]-x[Seg1[poselem[j]][0]]);
+				x2[j]=x[Seg3[poselem[j]][0]]+weight3*(x[Seg3[poselem[j]][1]]-x[Seg3[poselem[j]][0]]);
+				y1[j]=y[Seg1[poselem[j]][0]]+weight1*(y[Seg1[poselem[j]][1]]-y[Seg1[poselem[j]][0]]);
+				y2[j]=y[Seg3[poselem[j]][0]]+weight3*(y[Seg3[poselem[j]][1]]-y[Seg3[poselem[j]][0]]);
+				z1[j]=z[Seg1[poselem[j]][0]]+weight1*(z[Seg1[poselem[j]][1]]-z[Seg1[poselem[j]][0]]);
+				z2[j]=z[Seg3[poselem[j]][0]]+weight3*(z[Seg3[poselem[j]][1]]-z[Seg3[poselem[j]][0]]);
+				edge_l[j][0]=Seg1_num[poselem[j]];
+				edge_l[j][1]=Seg3_num[poselem[j]];
+
+			} else if (poselem23[poselem[j]]) {
+                x1[j]=x[Seg2[poselem[j]][0]]+weight2*(x[Seg2[poselem[j]][1]]-x[Seg2[poselem[j]][0]]);
+				x2[j]=x[Seg3[poselem[j]][0]]+weight3*(x[Seg3[poselem[j]][1]]-x[Seg3[poselem[j]][0]]);
+				y1[j]=y[Seg2[poselem[j]][0]]+weight2*(y[Seg2[poselem[j]][1]]-y[Seg2[poselem[j]][0]]);
+				y2[j]=y[Seg3[poselem[j]][0]]+weight3*(y[Seg3[poselem[j]][1]]-y[Seg3[poselem[j]][0]]);
+				z1[j]=z[Seg2[poselem[j]][0]]+weight2*(z[Seg2[poselem[j]][1]]-z[Seg2[poselem[j]][0]]);
+				z2[j]=z[Seg3[poselem[j]][0]]+weight3*(z[Seg3[poselem[j]][1]]-z[Seg3[poselem[j]][0]]);
+				edge_l[j][0]=Seg2_num[poselem[j]];
+				edge_l[j][1]=Seg3_num[poselem[j]];
+			} else {
+				//it shoud not go here
+			}
+			let test = new THREE.Vector3(x1[j], y1[j], z1[j]);
+			//console.log('helo', test.length());
+		}
+		//now that we have the segments, we must try to connect them...
+
+		//loop over the subcontours
+		while (!isempty(edge_l)) {
+			//take the right edge of the second segment and connect it to the next segments if any
+			let e1=edge_l[0][0];   let e2=edge_l[0][1];
+			let xc=[x1[0],x2[0]]; let yc=[y1[0],y2[0]]; let zc=[z1[0],z2[0]]; 
+
+			//erase the lines corresponding to this edge
+			//edge_l(1,:)=[];
+			//x1(1)=[]; x2(1)=[];
+			//y1(1)=[]; y2(1)=[];
+			//z1(1)=[]; z2(1)=[]
+			edge_l.splice(0,1);
+			x1.splice(0,1); x2.splice(0,1);
+			y1.splice(0,1); y2.splice(0,1);
+			z1.splice(0,1); z2.splice(0,1);
+			let [ro1,co1]=find(ArrayEqual(edge_l,e1));
+
+			while (!isempty(ro1)) {
+				if (co1==0) {
+					xc=[x2[ro1]].concat(xc); yc=[y2[ro1]].concat(yc); zc=[z2[ro1]].concat(zc);
+
+					//next edge:
+					e1=edge_l[ro1][1];
+
+				} else {
+					xc=[x1[ro1]].concat(xc); yc=[y1[ro1]].concat(yc); zc=[z1[ro1]].concat(zc);
+
+					//next edge:
+					e1=edge_l[ro1][0];
+				}
+
+				//erase the lines of this
+				edge_l.splice(ro1,1);
+				x1.splice(ro1,1); x2.splice(ro1,1);
+				y1.splice(ro1,1); y2.splice(ro1,1);
+				z1.splice(ro1,1); z2.splice(ro1,1);
+
+				//next connection
+				[ro1,co1]=find(ArrayEqual(edge_l,e1));
+			}
+
+			//same thing the other way (to the right)
+			let [ro2,co2]=find(ArrayEqual(edge_l,e2));
+
+			while (!isempty(ro2)) {
+
+				if (co2==0) {
+					xc=[x2[ro2]].concat(xc); yc=[y2[ro2]].concat(yc); zc=[z2[ro2]].concat(zc);
+
+					//next edge:
+					e2=edge_l[ro2][1];
+
+				} else {
+					xc=[x1[ro2]].concat(xc); yc=[y1[ro2]].concat(yc); zc=[z1[ro2]].concat(zc);
+
+					//next edge:
+					e2=edge_l[ro2][0];
+				}
+
+				//erase the lines of this
+				edge_l.splice(ro2,1);
+				x1.splice(ro2,1); x2.splice(ro2,1);
+				y1.splice(ro2,1); y2.splice(ro2,1);
+				z1.splice(ro2,1); z2.splice(ro2,1);
+
+				//next connection
+				[ro2,co2]=find(ArrayEqual(edge_l,e2));
+			}
+
+			//we now have one subcontour ready to be plotted
+			if (options.getfieldvalue('contouronly',0)) {
+				if (isplanet) {
+					hx = ArrayConcat(hx, ArrayConcat(xc, [NaN]));
+					hy = ArrayConcat(hy, ArrayConcat(yc, [NaN]));
+					hz = ArrayConcat(hz, ArrayConcat(zc, [NaN]));
+					//h=[h;patch('Xdata',[xc;NaN],'Ydata',[yc;NaN],'Zdata',[zc;NaN],'facecolor','none','linewidth',linewidth)];
+				} else {
+					hx = ArrayConcat(hx, ArrayConcat(xc, [NaN]));
+					hy = ArrayConcat(hy, ArrayConcat(yc, [NaN]));
+					hz = ArrayConcat(hz, ArrayConcat(zc, [NaN]));
+					//h=[h;patch('Xdata',[xc;NaN],'Ydata',[yc;NaN],'Zdata',zc,'Cdata',zc,'facecolor','none','edgecolor','flat','linewidth',linewidth)];
+				}
+				//hold on      
+			} else {
+				//dist = 5000;
+				dist = 0;
+				if (isplanet) {
+					if ((max(xc)-min(xc)+max(yc)-min(yc)+max(zc)-min(zc))<dist) { continue; }
+					hx = ArrayConcat(hx, ArrayConcat(xc, [NaN]));
+					hy = ArrayConcat(hy, ArrayConcat(yc, [NaN]));
+					hz = ArrayConcat(hz, ArrayConcat(zc, [NaN]));
+					//h=[h;patch('Xdata',[xc;NaN],'Ydata',[yc;NaN],'Zdata',[zc;NaN],'facecolor','none','edgecolor',color,'linewidth',linewidth)];
+					//c = horzcat([level, xc'; length(xc), yc'; length(xc), zc']);
+				} else {
+					if ((max(xc)-min(xc)+max(yc)-min(yc))<dist) { continue; }
+					hx = ArrayConcat(hx, ArrayConcat(xc, [NaN]));
+					hy = ArrayConcat(hy, ArrayConcat(yc, [NaN]));
+					hz = ArrayConcat(hz, ArrayConcat(zc, [NaN]));
+					//h=patch('Xdata',[xc;NaN],'Ydata',[yc;NaN],'facecolor','none','edgecolor',color,'linewidth',linewidth);
+					//c = horzcat([level, xc'; length(xc), yc']);
+				}
+				//clabel(c,h,'FontSize',10,'labelspacing',20000,'color',color);
+				//hold on
+			}
+			//break;
+		}
+	}
+
+	//Compute gl variables:
+	let scale = options.getfieldvalue('contourscale', 1.0005);
+	let node = new Node(
+		'canvas', canvas,
+		'options', options,
+		'md', md,
+		'name', 'contours',
+		'replaceNaN', false,
+		'shaderName', 'line_strip',
+		'lineWidth', options.getfieldvalue('linewidth', 1),
+		'scale', [scale, scale, scale]
+	);
+
+	node.patch('Vertices', [hx, hy, hz], 'FaceColor', 'none', 'EdgeColor', color);
+	//node.patch('Faces', elements, 'Vertices', vertices, 'FaceColor', 'none', 'EdgeColor', edgecolor);
+	//}}}
+} //}}}
